/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2007 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id$
 * -------------------------------------------------------------------------
 */

package org.ow2.petals.se.xslt;

import java.io.ByteArrayOutputStream;
import java.io.IOException;

import javax.xml.transform.Result;
import javax.xml.transform.Source;
import javax.xml.transform.stream.StreamResult;
import javax.xml.validation.Validator;

import org.xml.sax.SAXException;

/**
 * @author Christophe HAMERLING (chamerling) - eBM WebSourcing
 * 
 */
public class XsdImpl implements Xsd {

    /**
     * Creates a new instance of {@link XsdImpl}
     * 
     */
    public XsdImpl() {
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.ow2.petals.se.xslt.Xsd#validate(javax.xml.transform.Source)
     */
    public ByteArrayOutputStream validate(Source xml, Validator validator) {
        ByteArrayOutputStream bos = null;
        try {
            bos = validateSource(xml, validator);
        } catch (SAXException e) {
            throw new RuntimeException("Failed to validate message - "
                    + e.getClass().getSimpleName() + " - " + e.getMessage());
        } catch (IOException e) {
            throw new RuntimeException("Failed to validate message - "
                    + e.getClass().getSimpleName() + " - " + e.getMessage());
        }
        return bos;
    }

    /**
     * 
     * @param xml
     * @param validator
     * @return
     * @throws SAXException
     * @throws IOException
     */
    private ByteArrayOutputStream validateSource(Source xml, Validator validator)
            throws SAXException, IOException {
        ByteArrayOutputStream outputStream = new ByteArrayOutputStream();
        Result streamResult = new StreamResult(outputStream);
        validator.validate(xml, streamResult);
        return outputStream;
    }
}
